﻿Public Class Form1

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Me.Text = AppTitleAndVersion()
        Cmb_SourceFilePath.LoadRecentFiles("Theremino_Updater_RecentFiles1.txt")
        Cmb_DestinationFolderPath.LoadRecentFiles("Theremino_Updater_RecentFiles2.txt")
        Load_INI()
        Show()
        Refresh()
        EventsAreEnabled = True
    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        Save_INI()
        Cmb_SourceFilePath.SaveRecentFiles("Theremino_Updater_RecentFiles1.txt")
        Cmb_DestinationFolderPath.SaveRecentFiles("Theremino_Updater_RecentFiles2.txt")
    End Sub

    Private Sub Btn_PathLengthChecker_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_PathLengthChecker.Click
        Process.Start(Application.StartupPath + "\PathLengthChecker\PathLengthCheckerGUI.exe")
    End Sub

    Private Sub Cmb_SourceFilePath_DropDownClosed(ByVal sender As Object, ByVal e As System.EventArgs) Handles Cmb_SourceFilePath.DropDownClosed
        txt_FoundFiles.Select()
    End Sub
    Private Sub Cmb_DestinationFolderPath_DropDownClosed(ByVal sender As Object, ByVal e As System.EventArgs) Handles Cmb_DestinationFolderPath.DropDownClosed
        txt_FoundFiles.Select()
    End Sub
    Private Sub Cmb_SourceFilePath_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Cmb_SourceFilePath.TextChanged
        lbl_FoundDestinations.Text = "Found destinations"
        btn_Replace.Enabled = False
        txt_FoundFiles.Text = ""
        txt_FoundFiles.Select()
    End Sub
    Private Sub Cmb_DestinationFolderPath_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Cmb_DestinationFolderPath.TextChanged
        lbl_FoundDestinations.Text = "Found destinations"
        btn_Replace.Enabled = False
        txt_FoundFiles.Text = ""
        txt_FoundFiles.Select()
    End Sub

    Private Sub Btn_FindFiles_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_FindFiles.Click
        FindFiles()
    End Sub

    Private Sub chk_DifferentFilesOnly_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chk_DifferentFilesOnly.CheckedChanged
        If Not EventsAreEnabled Then Return
        lbl_FoundDestinations.Text = "Found destinations"
        btn_Replace.Enabled = False
        txt_FoundFiles.Text = ""
        Refresh()
    End Sub

    Private Sub btn_Replace_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_Replace.Click
        ReplaceAllFiles()
    End Sub

    ' =========================================================================
    '   Find all files in the DestinationFolderPath and subfolders
    ' =========================================================================
    Private FileNames(-1) As String
    Private DestinationFileNames(-1) As String
    Private Sub FindFiles()
        ' ---------------------------------------------------------------------------
        Cmb_SourceFilePath.Text = Cmb_SourceFilePath.Text.Trim
        Cmb_DestinationFolderPath.Text = Cmb_DestinationFolderPath.Text.Trim
        If Cmb_SourceFilePath.Text = "" Then Return
        If Cmb_DestinationFolderPath.Text = "" Then Return
        ' ---------------------------------------------------------------------------
        If Not IO.File.Exists(Cmb_SourceFilePath.Text) Then
            MessageBox.Show("Source file not found ", _
                 "Theremino Updater report", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Return
        End If
        If Not IO.Directory.Exists(Cmb_DestinationFolderPath.Text) Then
            MessageBox.Show("Destination folder not found ", _
                 "Theremino Updater report", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Return
        End If
        ' ---------------------------------------------------------------------------
        lbl_FoundDestinations.Text = " Working - Please wait "
        lbl_FoundDestinations.BackColor = Color.FromArgb(255, 220, 80)
        lbl_FoundDestinations.Refresh()
        txt_FoundFiles.Text = ""
        txt_FoundFiles.Refresh()
        Cmb_SourceFilePath.Enabled = False
        Cmb_DestinationFolderPath.Enabled = False
        chk_DifferentFilesOnly.Enabled = False
        Btn_FindFiles.Enabled = False
        btn_Replace.Enabled = False
        ' --------------------------------------------------------------------------- get files
        RecursiveLevel = 0
        ProgressBar1.Visible = True
        '
        ' --------------------------------------------------------------------------- no suffix 
        'FileNames = GetFilesRecursive(Cmb_DestinationFolderPath.Text, _
        '                              "*" + IO.Path.GetFileName(Cmb_SourceFilePath.Text))
        '
        ' --------------------------------------------------------------------------- allow suffix before the extension
        FileNames = GetFilesRecursive(Cmb_DestinationFolderPath.Text, _
                                 "*" + IO.Path.GetFileNameWithoutExtension(Cmb_SourceFilePath.Text) + _
                                 "*" + IO.Path.GetExtension(Cmb_SourceFilePath.Text))
        '
        ' --------------------------------------------------------------------------- show destinations
        ReDim DestinationFileNames(-1)
        If FileNames IsNot Nothing AndAlso FileNames.Length > 0 Then
            lbl_FoundDestinations.Text = " Found destinations ( " + FileNames.Length.ToString + " ) Please wait... "
            lbl_FoundDestinations.Refresh()
            For i As Int32 = 0 To FileNames.Length - 1
                ' ---------------------------------------------
                Dim f As String = FileNames(i)
                If IO.Path.GetDirectoryName(Cmb_SourceFilePath.Text) = IO.Path.GetDirectoryName(f) Then Continue For
                If chk_DifferentFilesOnly.Checked AndAlso IdenticalToSource(f) Then Continue For
                ' ---------------------------------------------
                ReDim Preserve DestinationFileNames(DestinationFileNames.Length)
                DestinationFileNames(DestinationFileNames.Length - 1) = f
                ' ---------------------------------------------
                txt_FoundFiles.Text += f + vbCrLf
                ' ---------------------------------------------
                Dim p As Int32 = 100 * (i + 1) \ FileNames.Length
                If p > 100 Then p = 100
                ProgressBar1.Value = p
            Next
            lbl_FoundDestinations.Text = "Found destinations ( " + DestinationFileNames.Length.ToString + " )"
            ' 
            If DestinationFileNames.Length > 0 Then
                btn_Replace.Enabled = True
            End If
        Else
            lbl_FoundDestinations.Text = "No destinations found"
        End If
        ProgressBar1.Visible = False
        ProgressBar1.Value = 0
        lbl_FoundDestinations.BackColor = Color.Transparent
        Cmb_SourceFilePath.Enabled = True
        Cmb_DestinationFolderPath.Enabled = True
        chk_DifferentFilesOnly.Enabled = True
        Btn_FindFiles.Enabled = True
    End Sub

    Private RecursiveLevel As Int32
    Function GetFilesRecursive(ByVal folder As String, ByVal wildcard As String) As String()
        Dim files As New List(Of String)
        Dim subfolders As String()
        On Error Resume Next
        subfolders = System.IO.Directory.GetDirectories(folder)
        On Error GoTo 0
        For i As Int32 = 0 To subfolders.Length - 1
            Dim subfolder As String = subfolders(i)
            If RecursiveLevel = 0 Then
                Dim p As Int32 = 100 * (i + 1) \ subfolders.Length
                If p > 100 Then p = 100
                ProgressBar1.Value = p
            End If
            Application.DoEvents()
            RecursiveLevel += 1
            files.AddRange(GetFilesRecursive(subfolder, wildcard))
        Next
        On Error Resume Next
        files.AddRange(System.IO.Directory.GetFiles(folder, wildcard))
        On Error GoTo 0
        RecursiveLevel -= 1
        Return files.ToArray
    End Function

    Private Function IdenticalToSource(ByVal f As String) As Boolean
        Return FileCompare(f, Cmb_SourceFilePath.Text)
    End Function

    Private Function FileCompare(ByVal file1 As String, ByVal file2 As String) As Boolean
        Dim file1byte As Integer
        Dim file2byte As Integer
        Dim fs1 As IO.FileStream
        Dim fs2 As IO.FileStream
        ' ---------------------------------------------- Determine if the same file was referenced two times.
        If (file1 = file2) Then Return True
        Try
            ' ---------------------------------------------- Open the two files.
            fs1 = New IO.FileStream(file1, IO.FileMode.Open, IO.FileAccess.Read)
            fs2 = New IO.FileStream(file2, IO.FileMode.Open, IO.FileAccess.Read)
            ' ---------------------------------------------- Check the file sizes
            If (fs1.Length <> fs2.Length) Then
                fs1.Close()
                fs2.Close()
                Return False
            End If
            ' ---------------------------------------------- Compare each byte until a different byte or file1 end
            Do
                file1byte = fs1.ReadByte()
                file2byte = fs2.ReadByte()
            Loop While file1byte = file2byte And file1byte <> -1
            ' ---------------------------------------------- Close the files.
            fs1.Close()
            fs2.Close()
        Catch
            txt_FoundFiles.Text += "ERROR - Can not open file for compare: " + file1 + vbCrLf
        End Try
        ' ---------------------------------------------- file1byte = file2byte only if the files are identical
        Return file1byte = file2byte
    End Function

    ' =========================================================================
    '   Replace all the files with the new version
    ' =========================================================================
    Private Sub ReplaceAllFiles()
        Dim n As Int32 = 0
        Dim source As String = Cmb_SourceFilePath.Text
        For Each dest As String In DestinationFileNames
            Try
                My.Computer.FileSystem.CopyFile(source, dest, True)
            Catch e As Exception
                MessageBox.Show("ERROR: Can not write the file: " + dest + vbCrLf + vbCrLf + _
                                "Please close all open files and retry.", _
                                "Theremino Updater report", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                lbl_FoundDestinations.Text = "Errors with some destinations."
                btn_Replace.Enabled = False
                txt_FoundFiles.Text = "Please, close all files and retry."
                Return
            End Try
        Next
        '
        MessageBox.Show("Updated " + DestinationFileNames.Length.ToString + " files.", _
                        "Theremino Updater report", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        '
        lbl_FoundDestinations.Text = "Found destinations"
        btn_Replace.Enabled = False
        txt_FoundFiles.Text = ""
    End Sub

End Class
